<?php /* Měření přístupové doby k velkému počtu souborů v závislosti
         na hloubce vnoření adresářové struktury.
         Po nastavení parametrů spusťte skript povelem  php fileorg.php
      */
// Nastavení parametrů.
$depths=array(1,2,3,6); // Testované hloubky vnoření H.
$N=10000; // Generovaný počet souborů pro každou hloubku vnoření, max. 1 milion.
 // Měl by odpovídat předpokládanému max. možnému počtu souborů v reálném provozu.
$MAXTEST=1000; // Počet testovaných souborů pro každou hloubku vnoření.
       // Vyšší počet poskytne přesnější výsledek, ale měření potrvá déle.
$ClusterSize=4096; // Použito pro odhad potřebného místa na disku.       
$FileSize=1024; // Velikost souborových vzorků. 
       // Měla by odpovídat průměrné velikosti souborů v reálném provozu.
        
// Pomocné parametry a funkce.
$FileContents=""; // Obsah vzorových souborů, pro účel testu irelevantní.
for ($n=0;$n<$FileSize/16;$n++) $FileContents.="0123456789ABCDEF";

function HomeDir() // Vrací adresář pro testované soubory, zakončený lomítkem.
{$Dir=@$_SERVER['argv'][1]; // Výchozí adresář volitelně zadaný jako argument skriptu. 
 if (!$Dir) $Dir="."; $HomeDir=realpath($Dir);
 $s=strpos($HomeDir,'/')===false?'\\':'/'; // Oddělovač adresářů v cestě.
 if (substr($HomeDir,-1)!=$s) $HomeDir.=$s; // Vždy zakončený oddělovačem.
 return $HomeDir;
}

function FullName($id,$H,$HomeDir) // Vrací úplný název souboru,
     // např. C:\www\img\H1\123456.txt  nebo /webroot/img/H3/12/34/123456.txt
{$id6=substr("00000$id",-6);  // Doplnění čísla souboru nulami zleva.
$s=substr($HomeDir,-1); // Lomítko nebo zpětné lomítko.
switch ($H) 
 {case 1: return $HomeDir.'H'.$H.$s.$id.'.txt';
  case 2: return $HomeDir.'H'.$H.$s.substr($id6,0,3).$s.$id.'.txt';
  case 3: return $HomeDir.'H'.$H.$s.substr($id6,0,2).$s.substr($id6,2,2).$s.$id.'.txt';
  case 6: return $HomeDir.'H'.$H.$s.$id6[0].$s.$id6[1].$s.$id6[2].$s.$id6[3].$s.$id6[4].$s.$id.'.txt';
  default: die("Unsupported depth=$H.\r\n");
 }
}

function LogMsg($msg) // Zapíše zprávu do deníku a na konsolu.
{echo $record=date("Y/m/d H:i:s ").$msg."\r\n";flush(); 
 file_put_contents(HomeDir()."fileorg.log",$record,FILE_APPEND);
}

// Start testu.
$HomeDir=HomeDir();
$dfB=disk_free_space($HomeDir); $dfMB=round($dfB/1048576);
if (5*$N*max($FileSize,$ClusterSize)>$dfB) 
 $N=round($dfB/5/max($FileSize,$ClusterSize)); // Sníží počet souborů při nedostatku místa.
LogMsg("Measuring average access time to N=$N files.");
LogMsg("Using directory \"$HomeDir\", $dfMB MB free.");
foreach ($depths as $H)
{LogMsg("Populating files at depth H=$H."); 
 if (file_exists(FullName($N-1,$H,$HomeDir)))
  LogMsg("Reusing already populated files.");
 else
 {$OldPercent=""; 
  for ($id=0;$id<$N;$id++) 
  {$Percent=round(100*$id/$N,-1); if ($Percent<>$OldPercent) 
   {$OldPercent=$Percent; echo $Percent." % populated.\r\n";
   }$NestedFile=FullName($id,$H,$HomeDir);
   @mkdir(pathinfo($NestedFile,PATHINFO_DIRNAME),0777,true);
   file_put_contents($NestedFile,$FileContents);
  }
 }
} LogMsg("Measuring performance for $MAXTEST times.");
foreach ($depths as $H)
{srand(1); // Fixní inicializace náhodnosti pro lépe reprodukovatelné výsledky. 
$StartTime=microtime(true); 
for ($i=0;$i<$MAXTEST;$i++) 
 {$FileHandle=fopen(FullName(rand(0,$N-1),$H,$HomeDir),"r"); fclose($FileHandle);
 } $Duration=round((microtime(true)-$StartTime)*1000/$MAXTEST,2); // V milisekundách.
 LogMsg("Access time at depth H=$H: $Duration ms");
}LogMsg("Test terminated. Results logged to \"fileorg.log\".");
?>
